﻿local frameeve = CreateFrame("FRAME",nil,UIParent)
	frameeve:RegisterEvent("VARIABLES_LOADED")
	frameeve:SetScript("OnEvent", function()
		if event == "VARIABLES_LOADED" then
			InnerFireHelper_Ini();
		end
	end)

local timer3 = 1;
local timer4 = 1;
local buff = false;
local inneresfeuer = GetSpellInfo(10952);


InnerFireHelperDB = {
	["Aufladungen"] = 10;
	["AufladungsMeldung"] = true;
	["EineMinuteMeldung"] = true;
	["SchwindenMeldung"] = true;
	["ZeigeFrame"] = true;
};


INNERFIREHELPER_SCHWINDET = " fade."
INNERFIREHELPER_AUFLADUNGEN_A = "Inner Fire: ";
INNERFIREHELPER_AUFLADUNGEN_E = " charges left.";
INNERFIREHELPER_AUFLADUNGEN_MINUTE = "Inner Fire: 1 minute left.";
INNERFIREHELPER_OPTIONS_MINUTE_H = "Show warning at 1 minute left";
INNERFIREHELPER_OTIONS_AUFlADUNGEN_H = "Show charges warning";
INNERFIREHELPER_OTIONS_SCHWINDET_H = "Show fade warning";
INNERFIREHELPER_OTIONS_FRAME_H = "Show Inner Fire Helper MiniBar";
INNERFIREHELPER_OTIONS_BUTTON_S = "Show InnerFire Icon when the buff is expired";
INNERFIREHELPER_OTIONS_AUFlADUNGEN = "How many charges to show warnig?";
INNERFIREHELPER_OTIONS_PLAYSOUND = "Play Sound on Inner Fire fade?"
INNERFIREHELPER_MISS = "Inner Fire miss!"
INNERFIREHELPER_OTIONS_ENTERCOMBAT = "Show Inner Fire miss on enter combat?"
INNERFIREHELPER_OTIONS_MINNIBARCONFIG = "Config Minibar"

INNERFIREHELPER_OPTCHANGE = "There are new Options for InnerFireHelper config now?"
INNERFIREHELPER_JA = "Yes"
INNERFIREHELPER_NEIN = "No"

INNERFIREHELPER_OPT_BLAU = "Blue"
INNERFIREHELPER_OPT_GRUN = "Green"
INNERFIREHELPER_OPT_ORANGE = "Orange"
INNERFIREHELPER_OPT_SCHWARZ = "Black"

INNERFIREHELPER_TRANSLATION_THX = " "

if ( GetLocale() == "deDE" ) then
	INNERFIREHELPER_SCHWINDET = " schwindet."
	INNERFIREHELPER_AUFLADUNGEN_A = "Inneres Feuer: ";
	INNERFIREHELPER_AUFLADUNGEN_E = " Aufladungen verbleibend.";
	INNERFIREHELPER_AUFLADUNGEN_MINUTE = "Inneres Feuer: 1 Minute verbleibend.";
	INNERFIREHELPER_OPTIONS_MINUTE_H = "Zeige Warnung bei 1 Minute verbleibend";
	INNERFIREHELPER_OTIONS_AUFlADUNGEN_H = "Zeige aufladungs Warnung";
	INNERFIREHELPER_OTIONS_SCHWINDET_H = "Zeige schwinden Warnung";
	INNERFIREHELPER_OTIONS_FRAME_H = "Zeige Inner Fire Helper MiniBar";
	INNERFIREHELPER_OTIONS_BUTTON_S = "Zeige InneresFeuer Icon wenn Buff abgelaufen";
	INNERFIREHELPER_OTIONS_AUFlADUNGEN = "Wieviele Aufladungen verbleibend bis zur Warnung?";
	INNERFIREHELPER_OTIONS_PLAYSOUND = "Sound abspielen wenn Inneres Feuer abgelaufen?"
	INNERFIREHELPER_MISS = "Inneres Feuer fehlt!"
	INNERFIREHELPER_OTIONS_ENTERCOMBAT = "Zeige Inneres Feuer fehlt bei beginnendem Kampf?"
	
	INNERFIREHELPER_OPTCHANGE = "Neue Optionen für InnerFireHelper nun einstellen?"
	INNERFIREHELPER_JA = "Ja"
	INNERFIREHELPER_NEIN = "Nein"
	
	INNERFIREHELPER_OPT_BLAU = "Blau"
	INNERFIREHELPER_OPT_GRUN = "Grün"
	INNERFIREHELPER_OPT_SCHWARZ = "Schwarz"
	
	INNERFIREHELPER_TRANSLATION_THX = " "
end

-- Spanish translation by luskaner @ wowinterface.com
if ( GetLocale() == "esES" ) then
	INNERFIREHELPER_SCHWINDET = " se desvanece."
	INNERFIREHELPER_AUFLADUNGEN_A = "Fuego Interno: ";
	INNERFIREHELPER_AUFLADUNGEN_E = " cargas quedan.";
	INNERFIREHELPER_AUFLADUNGEN_MINUTE = "Fuego Interno: Queda 1 minuto.";
	INNERFIREHELPER_OPTIONS_MINUTE_H = "Mostrar aviso cuando quede 1 minuto";
	INNERFIREHELPER_OTIONS_AUFlADUNGEN_H = "Mostrar aviso de Cargas";
	INNERFIREHELPER_OTIONS_SCHWINDET_H = "Mostrar aviso de desvanecimiento";
	INNERFIREHELPER_OTIONS_FRAME_H = "Mostrar la MiniBarra de 'Inner Fire Helper'";
	INNERFIREHELPER_OTIONS_BUTTON_S = "Mostrar Icono de FuegoInterno cuando la ventaja se haya acabado";
	INNERFIREHELPER_OTIONS_AUFlADUNGEN = "¿Con cúantas cargas mostrar aviso?";
	INNERFIREHELPER_OTIONS_PLAYSOUND = "¿Reproducir sonido cuando se desvanezca Fuego Interno?"
	INNERFIREHELPER_MISS = "¡Falta Fuego Interno!"
	INNERFIREHELPER_OTIONS_ENTERCOMBAT = "¿Mostrar si falta Fuego Interno al entrar en combate?"
	
	INNERFIREHELPER_TRANSLATION_THX = "Spanish translation by luskaner @ wowinterface.com"
end

-- French translation by Lúthien, Horde @ EU-La Croisade écarlate
if ( GetLocale() == "frFR" ) then
    INNERFIREHELPER_SCHWINDET = " évanouissement."
    INNERFIREHELPER_AUFLADUNGEN_A = "Feu intérieur : ";
    INNERFIREHELPER_AUFLADUNGEN_E = " charges restantes.";
    INNERFIREHELPER_AUFLADUNGEN_MINUTE = "Feu intérieur : une minute restante.";
    INNERFIREHELPER_OPTIONS_MINUTE_H = "Afficher un avertissement lorsqu'il reste une minute";
    INNERFIREHELPER_OTIONS_AUFlADUNGEN_H = "Afficher un avertissement lors des charges";
    INNERFIREHELPER_OTIONS_SCHWINDET_H = "Afficher un avertissement lors de l'évanouissement";
    INNERFIREHELPER_OTIONS_FRAME_H = "Afficher la mini-barre de InnerFireHelper";
    INNERFIREHELPER_OTIONS_BUTTON_S = "Afficher l'icône de Feu intérieur lorsque l'amélioration est expirée";
    INNERFIREHELPER_OTIONS_AUFlADUNGEN = "Combien faut-il de charges afin d'afficher l'avertissement ?";
	INNERFIREHELPER_OTIONS_PLAYSOUND = "Jouer un son lors de l'évanouissement du Feu intérieur ?"
	INNERFIREHELPER_MISS = "Feu intérieur manquant !"
	INNERFIREHELPER_OTIONS_ENTERCOMBAT = "Afficher le manque du Feu intérieur en entrant en combat ?"
	
	INNERFIREHELPER_TRANSLATION_THX = "French translation by Lúthien, Horde @ EU-La Croisade écarlate"
end

-- VARIABLES_LOADED
function InnerFireHelper_Ini()
	local _,Class=UnitClass("player");
	if (not InnerFireHelperDB["ShowIcon"]) then InnerFireHelperDB["ShowIcon"] = false end;
	if (not InnerFireHelperDB["Update"]) then InnerFireHelperDB["Update"] = true end;
	if (not InnerFireHelperDB["EnterCombat"]) then InnerFireHelperDB["EnterCombat"] = false end;
	if (not InnerFireHelperDB["PlaySound"]) then InnerFireHelperDB["PlaySound"] = false end;
	if (not InnerFireHelperDB["SoundVal"]) then InnerFireHelperDB["SoundVal"] = 2 end;
	if (not InnerFireHelperDB["SoundPath"]) then InnerFireHelperDB["SoundPath"] = "Sound\\interface\\RaidWarning.wav" end;
	if (not InnerFireHelperDB["ColorVal"]) then InnerFireHelperDB["ColorVal"] = 1 end;
	if (not InnerFireHelperDB["TextureVal"]) then InnerFireHelperDB["TextureVal"] = 1 end;
	if (not InnerFireHelperDB["TexturePath"]) then InnerFireHelperDB["TexturePath"] = "Interface\\TargetingFrame\\UI-StatusBar" end;
	if (not InnerFireHelperDB["Size"]) then InnerFireHelperDB["Size"] = 1.0 end;
	if (not InnerFireHelperDB["CombatText"]) then InnerFireHelperDB["CombatText"] = 1 end;

	if  Class == "PRIEST" then
		InnerFireHelper_CreateBar();
		InnerFireHelper_CreateIcon();
		InnerFireHelper_CreateMessageFrame();
		
		InnerFireHelper_CreateOptions();
		if InnerFireHelperDB["Update"] == true then
			StaticPopupDialogs["INNERFIRE_OPTCHANGE"] = {
				text = INNERFIREHELPER_OPTCHANGE,
				button1 = INNERFIREHELPER_JA,
				button2 = INNERFIREHELPER_NEIN,
				OnAccept = function()
					InterfaceOptionsFrame_OpenToCategory("InnerFireHelper");
				end,
				timeout = 0,
				whileDead = 1,
				hideOnEscape = 1
			};
			InnerFireHelperDB["Update"] = false;
		end
	end
end

function InnerFireHelper_CreateBar()
	local frame = CreateFrame("FRAME","InnerFireHelper",UIParent)
		frame:SetWidth(200)
		frame:SetHeight(20)
		frame:SetPoint("CENTER",UIParent)
	--frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background",
   --                                         edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
   --                                         edgeSize = 16,
   --                                         insets = { left = 4, right = 4, top = 4, bottom = 4 }});
		frame:SetMovable(true)
		frame:EnableMouse(true)
		frame:SetResizable(false)
		frame:RegisterForDrag("LeftButton")
		frame:RegisterForDrag("LeftButton", "RightButton")
		frame:SetScript("OnMouseDown", function()
			if (IsAltKeyDown()) then
				this:StartMoving()
			end;
		end)
		frame:SetScript("OnMouseUp", frame.StopMovingOrSizing)
		frame:SetScript("OnUpdate", function()
			InnerFireHelper:SetScale(InnerFireHelperDB["Size"])
			if InnerFireHelperDB["ZeigeFrame"] == true then
				InnerFireHelper:Show();
			else
				InnerFireHelper:Hide();
			end
			if InnerFireHelperDB["ShowIcon"] == true then
				InnerFireHelperIconFrame:Show();
			else
				InnerFireHelperIconFrame:Hide();
			end;
			local inneresfeuer = GetSpellInfo(10952);
			for i=1,40 do
				local buffname,_,_,buffcount,_,dur,x2 = UnitBuff("player",i);
					if buffname == inneresfeuer then
						buff = true;
						local x = -1*(GetTime()-x2);
						local xzeit = math.floor(x/60);
						local minu = math.floor(x / 60);
						local seku = format("%.0f", mod(x, 60));
						InneresFeuerText:SetTextColor(1.0, 1.0, 1.0, 1.0);
						InneresFeuerText:SetText(inneresfeuer.."("..buffcount..") - "..minu.."."..seku);
						InnerFireHelperStatus:SetValue(x);
						InnerFireHelperIconFrame:Hide();
						if minu < 1 then
							InneresFeuerText:SetTextColor(1.0, 0.0, 0.0, 1.0);
						end
						if minu == 0 and InnerFireHelperDB["EineMinuteMeldung"] == true and timer4 == 1 then
								InnerFireHelper_SetMessage(INNERFIREHELPER_AUFLADUNGEN_MINUTE)
								timer4 =0;
						end
						if minu ~= 0 then
							timer4 = 1;
						end
						if buffcount == InnerFireHelperDB["Aufladungen"] then
							InneresFeuerText:SetTextColor(1.0, 0.0, 0.0, 1.0);
							if InnerFireHelperDB["AufladungsMeldung"] == true and timer3 == 1 then
								InnerFireHelper_SetMessage(INNERFIREHELPER_AUFLADUNGEN_A..InnerFireHelperDB["Aufladungen"]..INNERFIREHELPER_AUFLADUNGEN_E)
								timer3 = 0;
							end
						end
						if buffcount ~= InnerFireHelperDB["Aufladungen"] then
							timer3 = 1;
						end
					end
			end
		end)
		
	local InneresFeuerText = frame:CreateFontString("InneresFeuerText","OVERLAY","GameFontNormal")
		InneresFeuerText:SetPoint("TOPLEFT", frame, "TOPLEFT", 22, 0)
		InneresFeuerText:SetText(inneresfeuer.."(0) - 0.0");
		InneresFeuerText:SetHeight(20)
		InneresFeuerText:SetTextColor(1.0, 0.0, 0.0, 1.0);

	local InneresFeuerIcon = frame:CreateTexture("InnerFireHelperIcon","OVERLAY")
		InneresFeuerIcon:SetPoint("TOPLEFT", frame, "TOPLEFT")
		InneresFeuerIcon:SetTexture("Interface\\Icons\\spell_holy_innerfire")
		InneresFeuerIcon:SetHeight(20)
		InneresFeuerIcon:SetWidth(20)

	local b=CreateFrame("STATUSBAR","InnerFireHelperStatus",frame,"TextStatusBar")
		b:SetFrameStrata("BACKGROUND")
		b:SetWidth(180)
		b:SetHeight(20)
		b:SetPoint("TOPLEFT", frame, "TOPLEFT", 19, 0)
		b:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar","BACKGROUND")
		b:SetMinMaxValues(0, 1800)
		b:SetValue(0)
		b:SetStatusBarColor(1.0, 0.0, 1.0, 1.0)
		b:SetScript("OnUpdate", function()
			InnerFireHelper_SetBarColor(InnerFireHelperStatus)
			InnerFireHelperStatus:SetStatusBarTexture(InnerFireHelperDB["TexturePath"])
		end)
end

function InnerFireHelper_CreateIcon()
	local iconframe = CreateFrame("FRAME","InnerFireHelperIconFrame",UIParent)
		iconframe:SetWidth(32)
		iconframe:SetHeight(32)
		iconframe:SetPoint("CENTER",UIParent)
		iconframe:SetMovable(true)
		iconframe:EnableMouse(true)
		iconframe:SetResizable(false)
		iconframe:RegisterForDrag("LeftButton")
		iconframe:RegisterForDrag("LeftButton", "RightButton")
		iconframe:SetScript("OnMouseDown", function()
			if (IsAltKeyDown()) then
				this:StartMoving()
			end;
		end)
		iconframe:SetScript("OnMouseUp", iconframe.StopMovingOrSizing)

	local InneresFeuerIcon2 = iconframe:CreateTexture("InnerFireHelperIcon2","OVERLAY")
		InneresFeuerIcon2:SetPoint("TOPLEFT", iconframe, "TOPLEFT")
		InneresFeuerIcon2:SetTexture("Interface\\Icons\\spell_holy_innerfire")
		InneresFeuerIcon2:SetHeight(32)
		InneresFeuerIcon2:SetWidth(32)
end

function InnerFireHelper_CreateMessageFrame()
	local frame2 = CreateFrame("MessageFrame","InnerFireHelperMessageFrame",UIParent)
		frame2:SetWidth(UIParent:GetWidth())
		frame2:SetHeight(25)
		frame2:SetTimeVisible(3)
		frame2:SetFadeDuration(0.5)
		frame2:SetFont("Fonts\\FRIZQT__.TTF", 23, "OUTLINE")
		frame2:SetPoint("CENTER",UIParent)
		frame2:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		frame2:RegisterEvent("PLAYER_DEAD")
		frame2:RegisterEvent("PLAYER_REGEN_DISABLED")
		frame2:RegisterEvent("CHAT_MSG_ADDON")
		frame2:SetScript("OnEvent", function()
			local inneresfeuer = GetSpellInfo(10952);
			if(arg2 == "SPELL_AURA_REMOVED" and arg10 == inneresfeuer and arg4 == UnitName("player")) then
				InnerFireHelper_SetMessage(inneresfeuer..INNERFIREHELPER_SCHWINDET)
				InneresFeuerText:SetText(inneresfeuer.."(0) - 0.0");
				InneresFeuerText:SetTextColor(1.0, 0.0, 0.0, 1.0);
				InnerFireHelperStatus:SetValue(0);
				buff = false;
				if InnerFireHelperDB["PlaySound"] == true then
					PlaySoundFile(InnerFireHelperDB["SoundPath"]);
				end
				if InnerFireHelperDB["ShowIcon"] == true then
					InnerFireHelperIconFrame:Show();
				elseif InnerFireHelperDB["ShowIcon"] == false then
					InnerFireHelperIconFrame:Hide();
				end;
			end
			if event == "CHAT_MSG_ADDON" then
				InnerFireHelper_AddonMessage(arg1, arg2, arg3, arg4)
			end
			if event == "PLAYER_DEAD" then
				InneresFeuerText:SetText(inneresfeuer.."(0) - 0.0");
				InneresFeuerText:SetTextColor(1.0, 0.0, 0.0, 1.0);
				InnerFireHelperStatus:SetValue(0);
				buff = false;
				if InnerFireHelperDB["ShowIcon"] == true then
					InnerFireHelperIconFrame:Show();
				elseif InnerFireHelperDB["ShowIcon"] == false then
					InnerFireHelperIconFrame:Hide();
				end;
			end
			if event == "PLAYER_REGEN_DISABLED" then
				if buff == false and InnerFireHelperDB["EnterCombat"] == true then
					InnerFireHelper_SetMessage(INNERFIREHELPER_MISS)
				end
			end
		end)
		frame2:SetScript("OnUpdate", function()
			if InnerFireHelperDB["ZeigeFrame"] == false then
			for i=1,40 do
				local buffname,_,_,buffcount,_,dur,x2 = UnitBuff("player",i);
					if buffname == inneresfeuer then
						buff = true;
						local x = -1*(GetTime()-x2);
						local minu = math.floor(x / 60);
						InnerFireHelperIconFrame:Hide();
						if minu == 0 and InnerFireHelperDB["EineMinuteMeldung"] == true and timer4 == 1 then
							InnerFireHelper_SetMessage(INNERFIREHELPER_AUFLADUNGEN_MINUTE)
							timer4 =0;
						end
						if minu ~= 0 then
							timer4 = 1;
						end
						if buffcount == InnerFireHelperDB["Aufladungen"] then
							if InnerFireHelperDB["AufladungsMeldung"] == true and timer3 == 1 then
								InnerFireHelper_SetMessage(INNERFIREHELPER_AUFLADUNGEN_A..InnerFireHelperDB["Aufladungen"]..INNERFIREHELPER_AUFLADUNGEN_E)
								timer3 = 0;
							end
						end
						if buffcount ~= InnerFireHelperDB["Aufladungen"] then
							timer3 = 1;
						end
					end
			end
			end
		end)
end
--test 
function InnerFireHelper_AddonMessage(prefix, message, channel, sender)
	if prefix == "INNERFIREHELPER" then
		if message == "checkaddon" then
			SendAddonMessage("INNERFIREHELPER", "checkaddontrue", "WHISPER", sender)
		end
		if message == "checkaddontrue" then
			DEFAULT_CHAT_FRAME:AddMessage("|cff1eff00"..sender.." hat Addon.")
		end
	end
end
-- test end
function InnerFireHelper_SetMessage(msg)
	if InnerFireHelperDB["CombatText"] == 1 then
		InnerFireHelperMessageFrame:AddMessage(msg, 1.0, 0.0, 0.0)
	elseif InnerFireHelperDB["CombatText"] == 2 then
		if( IsAddOnLoaded("Blizzard_CombatText"))  then
			CombatText_AddMessage(msg, COMBAT_TEXT_SCROLL_FUNCTION, 1.0, 0.0, 0.0, "crit", false)
		else
			InnerFireHelperMessageFrame:AddMessage(msg, 1.0, 0.0, 0.0)
		end
	elseif InnerFireHelperDB["CombatText"] == 3 then
		Parrot:ShowMessage(textmessage, nil, 1, 255, 0, 0, nil, nil)
	elseif InnerFireHelperDB["CombatText"] == 4 then	
		SCT:DisplayText(textmessage, {r = 1.0, g = 0.0, b = 0.0}, false, "event", 1, anitype)
	elseif InnerFireHelperDB["CombatText"] == 5 then
		MikSBT.DisplayMessage(msg, MikSBT.DISPLAYTYPE_NOTIFICATION, false, 1.0 * 255, 0.0 * 255, 0.0 * 255)	
	end
end

function InnerFireHelper_SetBarColor(bar)
	-- Blau
	if InnerFireHelperDB["ColorVal"] == 1 then
		bar:SetStatusBarColor(0.0, 0.0, 1.0, 1.0)
	-- Grün
	elseif InnerFireHelperDB["ColorVal"] == 2 then
		bar:SetStatusBarColor(0.0, 1.0, 0.0, 1.0)
	-- Orange
	elseif InnerFireHelperDB["ColorVal"] == 3 then
		bar:SetStatusBarColor(1.0, 0.49, 0.04, 1.0)
	-- schwarz
	elseif InnerFireHelperDB["ColorVal"] == 4 then
		bar:SetStatusBarColor(0.0, 0.0, 0.0, 1.0)
	end
end
