﻿-- OPTIONS FUNC
 function InnerFireHelper_Close()
 	local text = edit1:GetNumber();
	InnerFireHelperDB["Aufladungen"]=text;
 end

-- OPTIONS
function InnerFireHelper_CreateOptions()
	local panel = CreateFrame( "Frame", "InnerFireHelperPanel", UIParent );
		panel.name = "InnerFireHelper";
		panel.okay = function (self) InnerFireHelper_Close(); end;

	local OptionUberschrift = panel:CreateFontString(nil,"HIGH","GameFontNormal")
		OptionUberschrift:SetPoint("CENTER", panel, "TOP", 0, -10)
		OptionUberschrift:SetText("InnerFireHelper")

	local Check4 = CreateFrame("CheckButton", "check4", panel, "UICheckButtonTemplate")
		Check4:SetPoint("LEFT", panel, "TOPLEFT", 5, -30)
		Check4:SetWidth(25)
		Check4:SetHeight(25)
		Check4:SetScript("OnUpdate", function()
			getglobal(this:GetName().."Text"):SetText(INNERFIREHELPER_OTIONS_FRAME_H);
			if InnerFireHelperDB["ZeigeFrame"] == true then
				this:SetChecked(1);
			end
		end)
		Check4:SetScript("OnClick", function()
			if InnerFireHelperDB["ZeigeFrame"] == true then
				InnerFireHelperDB["ZeigeFrame"] = false;
				InnerFireHelper:Hide();
			else
				InnerFireHelperDB["ZeigeFrame"] = true;
				InnerFireHelper:Show();
			end
		end)

	local Check1 = CreateFrame("CheckButton", "check1", panel, "UICheckButtonTemplate")
		Check1:SetPoint("LEFT", panel, "TOPLEFT", 5, -60)
		Check1:SetWidth(25)
		Check1:SetHeight(25)
		Check1:SetScript("OnUpdate", function()
		getglobal(this:GetName().."Text"):SetText(INNERFIREHELPER_OPTIONS_MINUTE_H);
			if InnerFireHelperDB["EineMinuteMeldung"] == true then
				this:SetChecked(1);
			end
		end)
		Check1:SetScript("OnClick", function()
			if InnerFireHelperDB["EineMinuteMeldung"] == true then
				InnerFireHelperDB["EineMinuteMeldung"] = false;
	
			else
				InnerFireHelperDB["EineMinuteMeldung"] = true;
			end
		end)

	local Check2 = CreateFrame("CheckButton", "check2", panel, "UICheckButtonTemplate")
		Check2:SetPoint("LEFT", panel, "TOPLEFT", 5, -80)
		Check2:SetWidth(25)
		Check2:SetHeight(25)
		Check2:SetScript("OnUpdate", function()
			getglobal(this:GetName().."Text"):SetText(INNERFIREHELPER_OTIONS_AUFlADUNGEN_H);
			if InnerFireHelperDB["AufladungsMeldung"] == true then
				this:SetChecked(1);
			end
		end)
		Check2:SetScript("OnClick", function()
			if InnerFireHelperDB["AufladungsMeldung"] == true then
				InnerFireHelperDB["AufladungsMeldung"] = false;
			else
				InnerFireHelperDB["AufladungsMeldung"] = true;
			end
		end)

	local Check3 = CreateFrame("CheckButton", "check3", panel, "UICheckButtonTemplate")
		Check3:SetPoint("LEFT", panel, "TOPLEFT", 5, -100)
		Check3:SetWidth(25)
		Check3:SetHeight(25)
		Check3:SetScript("OnUpdate", function()
			getglobal(this:GetName().."Text"):SetText(INNERFIREHELPER_OTIONS_SCHWINDET_H);
			if InnerFireHelperDB["SchwindenMeldung"] == true then
				this:SetChecked(1);
			end
		end)
		Check3:SetScript("OnClick", function()
			if InnerFireHelperDB["SchwindenMeldung"] == true then
				InnerFireHelperDB["SchwindenMeldung"] = false;
			else
				InnerFireHelperDB["SchwindenMeldung"] = true;
			end
		end)

	local Check5 = CreateFrame("CheckButton", "check5", panel, "UICheckButtonTemplate")
		Check5:SetPoint("LEFT", panel, "TOPLEFT", 5, -120)
		Check5:SetWidth(25)
		Check5:SetHeight(25)
		Check5:SetScript("OnUpdate", function()
			getglobal(this:GetName().."Text"):SetText(INNERFIREHELPER_OTIONS_BUTTON_S);
			if InnerFireHelperDB["ShowIcon"] == true then
				this:SetChecked(1);
			end
		end)
		Check5:SetScript("OnClick", function()
			if InnerFireHelperDB["ShowIcon"] == true then
				InnerFireHelperDB["ShowIcon"] = false;
			else
				InnerFireHelperDB["ShowIcon"] = true;
			end
		end)	
	
	local Check6 = CreateFrame("CheckButton", "check6", panel, "UICheckButtonTemplate")
		Check6:SetPoint("LEFT", panel, "TOPLEFT", 5, -140)
		Check6:SetWidth(25)
		Check6:SetHeight(25)
		Check6:SetScript("OnUpdate", function()
			getglobal(this:GetName().."Text"):SetText(INNERFIREHELPER_OTIONS_PLAYSOUND);
			if InnerFireHelperDB["PlaySound"] == true then
				this:SetChecked(1);
			end
		end)
		Check6:SetScript("OnClick", function()
			if InnerFireHelperDB["PlaySound"] == true then
				InnerFireHelperDB["PlaySound"] = false;
			else
				InnerFireHelperDB["PlaySound"] = true;
			end
		end)
		
	local SoundDropDownMenu = CreateFrame("Frame", "SoundDropDownMenu", panel, "UIDropDownMenuTemplate")
		SoundDropDownMenu:SetPoint("LEFT", panel, "TOPLEFT", 15, -165)
		SoundDropDownMenu:SetScript("OnShow", function()
			UIDropDownMenu_Initialize(SoundDropDownMenu, InnerFireHelperSoundDropDownMenu_Initialise)
			UIDropDownMenu_SetSelectedID(SoundDropDownMenu, InnerFireHelperDB["SoundVal"])
		end)
	    UIDropDownMenu_SetWidth(SoundDropDownMenu, 100)
		UIDropDownMenu_SetButtonWidth(SoundDropDownMenu, 20)

	local Check7 = CreateFrame("CheckButton", "check7", panel, "UICheckButtonTemplate")
		Check7:SetPoint("LEFT", panel, "TOPLEFT", 5, -185)
		Check7:SetWidth(25)
		Check7:SetHeight(25)
		Check7:SetScript("OnUpdate", function()
			getglobal(this:GetName().."Text"):SetText(INNERFIREHELPER_OTIONS_ENTERCOMBAT);
			if InnerFireHelperDB["EnterCombat"] == true then
				this:SetChecked(1);
			end
		end)
		Check7:SetScript("OnClick", function()
			if InnerFireHelperDB["EnterCombat"] == true then
				InnerFireHelperDB["EnterCombat"] = false;
			else
				InnerFireHelperDB["EnterCombat"] = true;
			end
		end)
		
	local Opt1 = panel:CreateFontString("InnerFireHelperOpt1","OVERLAY","GameFontNormalSmall")
		Opt1:SetPoint("TOPLEFT", panel, "TOPLEFT", 5, -190)
		Opt1:SetHeight(20)
		Opt1:SetText(INNERFIREHELPER_OTIONS_AUFlADUNGEN)	
		
	local Edit1 = CreateFrame("EditBox", "edit1", panel, "InputBoxTemplate")
		Edit1:SetPoint("LEFT", panel, "TOPLEFT", 15, -220)
		Edit1:SetWidth(32)
		Edit1:SetHeight(32)
		Edit1:SetAutoFocus(false)
		Edit1:SetTextInsets(0, 8, 0, 0)
		Edit1:SetNumeric(true)
		Edit1:SetMaxLetters(2)
		Edit1:SetScript("OnEnterPressed", function()
			this:ClearFocus();
			local text = this:GetNumber();
			InnerFireHelperDB["Aufladungen"]=text;
		end)
		Edit1:SetScript("OnShow", function()
			this:SetNumber(InnerFireHelperDB["Aufladungen"]);
		end)
		
	local Opt2 = panel:CreateFontString("InnerFireHelperOpt2","OVERLAY","GameFontNormalSmall")
		Opt2:SetPoint("TOPLEFT", panel, "TOPLEFT", 5, -250)
		Opt2:SetHeight(20)
		Opt2:SetText(INNERFIREHELPER_OTIONS_MINNIBARCONFIG)	

	local ba=CreateFrame("STATUSBAR","InnerFireHelperStatusOpt",panel,"TextStatusBar")
		ba:SetFrameStrata("BACKGROUND")
		ba:SetWidth(50)
		ba:SetHeight(20)
		ba:SetPoint("TOPLEFT", panel, "TOPLEFT", 5, -270)
		ba:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar","BACKGROUND")
		ba:SetMinMaxValues(0, 1)
		ba:SetValue(1)
		ba:SetStatusBarColor(1.0, 0.0, 1.0, 1.0)
		ba:SetScript("OnUpdate", function()
			InnerFireHelper_SetBarColor(InnerFireHelperStatusOpt)
			InnerFireHelperStatusOpt:SetStatusBarTexture(InnerFireHelperDB["TexturePath"])
		end)
		
	local ColorDropDownMenu = CreateFrame("Frame", "ColorDropDownMenu", panel, "UIDropDownMenuTemplate")
		ColorDropDownMenu:SetPoint("LEFT", panel, "TOPLEFT", 50, -282)
		ColorDropDownMenu:SetScript("OnShow", function()
			UIDropDownMenu_Initialize(ColorDropDownMenu, InnerFireHelperColorDropDownMenu_Initialise)
			UIDropDownMenu_SetSelectedID(ColorDropDownMenu, InnerFireHelperDB["ColorVal"])
		end)
	    UIDropDownMenu_SetWidth(ColorDropDownMenu, 80)
		UIDropDownMenu_SetButtonWidth(ColorDropDownMenu, 20)
		
	local TextureDropDownMenu = CreateFrame("Frame", "TextureDropDownMenu", panel, "UIDropDownMenuTemplate")
		TextureDropDownMenu:SetPoint("LEFT", panel, "TOPLEFT", 150, -282)
		TextureDropDownMenu:SetScript("OnShow", function()
			UIDropDownMenu_Initialize(TextureDropDownMenu, InnerFireHelperTextureDropDownMenu_Initialise)
			UIDropDownMenu_SetSelectedID(TextureDropDownMenu, InnerFireHelperDB["TextureVal"])
		end)
	    UIDropDownMenu_SetWidth(TextureDropDownMenu, 100)
		UIDropDownMenu_SetButtonWidth(TextureDropDownMenu, 20)
		

	local sizeslider = CreateFrame("Slider", "ScaleSlider", panel, "OptionsSliderTemplate")
		sizeslider:SetMinMaxValues(0.5, 2.0)
		sizeslider:SetValueStep(0.1)
		sizeslider:SetWidth(200)
		getglobal('ScaleSliderLow'):SetText("0.5")
		getglobal('ScaleSliderHigh'):SetText("2.0")
		sizeslider:SetScript('OnShow', function(self) self:SetValue(InnerFireHelperDB["Size"]) end)
		sizeslider:SetScript("OnValueChanged", function(self)
			local newvalue = math.floor(self:GetValue() * 10) / 10
			InnerFireHelperDB["Size"] = newvalue;
			getglobal(this:GetName().."Text"):SetText("|cffffd200MiniBarSize ("..newvalue..")");
		end)
		sizeslider:SetPoint("LEFT", panel, "TOPLEFT", 10, -315)
		
		
	local Opt3 = panel:CreateFontString("InnerFireHelperOpt3","OVERLAY","GameFontNormalSmall")
		Opt3:SetPoint("TOPLEFT", panel, "TOPLEFT", 5, -330)
		Opt3:SetHeight(20)
		Opt3:SetText("CombatText")	
		
	local CombatTextDropDownMenu = CreateFrame("Frame", "CombatTextDropDownMenu", panel, "UIDropDownMenuTemplate")
		CombatTextDropDownMenu:SetPoint("LEFT", panel, "TOPLEFT", 5, -360)
		CombatTextDropDownMenu:SetScript("OnShow", function()
			UIDropDownMenu_Initialize(CombatTextDropDownMenu, InnerFireHelperCombatTextDropDownMenu_Initialise)
			UIDropDownMenu_SetSelectedID(CombatTextDropDownMenu, InnerFireHelperDB["CombatText"])
		end)
	    UIDropDownMenu_SetWidth(CombatTextDropDownMenu, 150)
		UIDropDownMenu_SetButtonWidth(CombatTextDropDownMenu, 20)

		
	local Name = panel:CreateFontString("InnerFireHelperOpt1","OVERLAY","GameFontNormalSmall")
		Name:SetPoint("TOPLEFT", panel, "TOPLEFT", 5, -390)
		Name:SetHeight(20)
		Name:SetText(INNERFIREHELPER_TRANSLATION_THX)
		
	local Name = panel:CreateFontString("InnerFireHelperOpt1","OVERLAY","GameFontNormalSmall")
		Name:SetPoint("TOPLEFT", panel, "TOPLEFT", 5, -405)
		Name:SetHeight(20)
		Name:SetText("Addon by Calí @ EU-Nera'thor PvP (Horde)")
		
InterfaceOptions_AddCategory(panel);
end
